// KEKS/CM -- KEKS-encoded cryptographic messages
// Copyright (C) 2024-2025 Sergey Matveev <stargrave@stargrave.org>
//
// This program is free software: you can redistribute it and/or modify
// it under the terms of the GNU Lesser General Public License as
// published by the Free Software Foundation, version 3 of the License.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU Lesser General Public License for more details.
//
// You should have received a copy of the GNU Lesser General Public
// License along with this program.  If not, see <http://www.gnu.org/licenses/>.

package ed25519blake2b

import (
	"hash"

	"go.cypherpunks.su/keks/cm/hash/merkle"
	"golang.org/x/crypto/blake2b"
)

func NewMerkleHasher(chunkLen, workers int) hash.Hash {
	return merkle.NewHasher(
		func() hash.Hash {
			h, e := blake2b.New512([]byte(merkle.Leaf))
			if e != nil {
				panic(e)
			}
			return h
		},
		func() hash.Hash {
			h, e := blake2b.New512([]byte(merkle.Node))
			if e != nil {
				panic(e)
			}
			return h
		},
		func(h hash.Hash) hash.Hash {
			h.Reset()
			return h
		},
		func(h hash.Hash) hash.Hash {
			h.Reset()
			return h
		},
		chunkLen,
		workers,
	)
}
